const http = require('http');

var sendScriptJob = function( scriptObj , callback ){
  var timeA =  Date.now()

////// POST ////////////

  var postData = JSON.stringify( scriptObj );

  var options = {
    hostname: 'localhost',
    port: 8000,
    method: 'POST',
    headers: {
      'Content-Type': 'application/json',
    }
  };

  var request = http.request(options, function( response ){
    console.log('response statusCode ', response.statusCode);

    var body = '';

    response.on('data', function(chunk) {
      // console.log('chunk', chunk.toString() );
        body += chunk;
    });
    response.on('end', function() {
      // console.log('body', body);
      console.log('!!! http-client.js - SANDBOX RESPONSE TIME  !!! ', Date.now() - timeA );
      // console.log('http-client.js - body: ', body);
      body = JSON.parse( body )
      if ( response.statusCode === 200 ){
        callback( null, body )
      }else{
        callback( body, null )
      }

    });

    response.on('error', function() {
      console.log('response error ', body);
      // console.log('!!! http-client.js - SANDBOX RESPONSE TIME  !!! ', Date.now() - timeA );
      // // console.log('http-client.js - body: ', body);
      // body = JSON.parse( body )
      // callback( null, body )
    });
  });

  //timeout on loops requirs error event after data event
  request.on('error', function(e) {
    console.log('http-client.js - Got error:', e.message );
    callback( { message: e.message, statusCode: 500 } , null )

  });

  // write data to request body
  request.write(postData);
  request.end();

}

// sendScriptJob( null, function(err, res ){
//   console.log('res', res);
// })

module.exports = sendScriptJob
